#include "at91sam7s256.h"
//#include "at91sam7s.h"
#include "Dbgu.h"

//Global Pointer to Dbgu
AT91PS_DBGU pDBGU = AT91C_BASE_DBGU;

void DbguInit(unsigned int baud)
{
	//Die Pins 9 und 10 werden dem Peripheriecontroller A zugewiesen.
	//Dieser hat somit die Kontrolle ber sie.
	*AT91C_PIOA_PDR = AT91C_PA9_DRXD |  // Enable RxD1 Pin
					AT91C_PA10_DTXD;   // Enable TxD1 Pin

	//Dann wird ein Reset der Schnittstelle ausgelst
	pDBGU->DBGU_CR = AT91C_US_RSTRX |   // Reset Receiver
	                  AT91C_US_RSTTX |   // Reset Transmitter
	                  AT91C_US_RXDIS |   // Receiver Disable
	                  AT91C_US_TXDIS;    // Transmitter Disable

	//Im Mode Register werden alle Einstellungen durchgefhrt
	  pDBGU->DBGU_MR = AT91C_US_USMODE_NORMAL |  // Normal Mode
	                  AT91C_US_CLKS_CLOCK    |  // Clock = MCK
	                  AT91C_US_CHRL_8_BITS   |  // 8-bit Data
	                  AT91C_US_PAR_NONE      |  // No Parity
	                  AT91C_US_NBSTOP_1_BIT;    // 1 Stop Bit

	//die Baudrate wird gesetzt
	  pDBGU->DBGU_BRGR = baud;

	//und die Schnittstelle aktiviert
	  pDBGU->DBGU_CR = AT91C_US_RXEN  |  // Receiver Enable
	                  AT91C_US_TXEN;    // Transmitter Enable
}

char DbguPChr(char ch)
{
	while (!(pDBGU->DBGU_CSR & AT91C_US_TXRDY)); // Wait for Empty Tx Buffer
	return (pDBGU->DBGU_THR = ch);               // Transmit Characte
}

char DbguGChr(void)
{
	while (!(pDBGU->DBGU_CSR & AT91C_US_RXRDY));  // Wait for Full Rx Buffer
	return (pDBGU->DBGU_RHR);                     // Read Character

}

void DbguPStr(char* str)
{
    // send characters until null received
	while (*str != 0)
	{
		DbguPChr(*str);
		str++;
	}
}

